# azure.mgmt.cdn.models module

exception `azure.mgmt.cdn.models.``ErrorResponseException`(deserialize, response, *args)

  Bases: `msrest.exceptions.HttpOperationError`

  Server responsed with exception of type: ‘ErrorResponse’.

  Parameters:

  - deserialize – A deserializer
  - response – Server response to be deserialized.

class `azure.mgmt.cdn.models.``CacheExpirationActionParameters`(*, cache_behavior, cache_duration: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Defines the parameters for the cache expiration action.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables:

  - odatatype (str) – Required. Default value: “#Microsoft.Azure.Cdn.Models.DeliveryRuleCacheExpirationActionParameters” .
  - cache_type (str) – Required. The level at which the content needs to be cached. Default value: “All” .

  Parameters:

  - cache_behavior (str or CacheBehavior) – Required. Caching behavior for the requests. Possible values include: ‘BypassCache’, ‘Override’, ‘SetIfMissing’
  - cache_duration (str) – The duration for which the content needs to be cached. Allowed format is [d.]hh:mm:ss

  `cache_type` = 'All'
  `odatatype` = '#Microsoft.Azure.Cdn.Models.DeliveryRuleCacheExpirationActionParameters'

class `azure.mgmt.cdn.models.``CacheKeyQueryStringActionParameters`(*, query_string_behavior, query_parameters: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Defines the parameters for the cache-key query string action.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables: | odatatype (str) – Required. Default value: “#Microsoft.Azure.Cdn.Models.DeliveryRuleCacheKeyQueryStringBehaviorActionParameters” .

  Parameters:

  - query_string_behavior (str or QueryStringBehavior) – Required. Caching behavior for the requests. Possible values include: ‘Include’, ‘IncludeAll’, ‘Exclude’, ‘ExcludeAll’
  - query_parameters (str) – query parameters to include or exclude (comma separated).

  `odatatype` = '#Microsoft.Azure.Cdn.Models.DeliveryRuleCacheKeyQueryStringBehaviorActionParameters'

class `azure.mgmt.cdn.models.``CdnCertificateSourceParameters`(*, certificate_type, **kwargs)

  Bases: `msrest.serialization.Model`

  Defines the parameters for using CDN managed certificate for securing custom domain.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables: | odatatype (str) – Required. Default value: “#Microsoft.Azure.Cdn.Models.CdnCertificateSourceParameters” .
  Parameters: | certificate_type (str or CertificateType) – Required. Type of certificate used. Possible values include: ‘Shared’, ‘Dedicated’

  `odatatype` = '#Microsoft.Azure.Cdn.Models.CdnCertificateSourceParameters'

class `azure.mgmt.cdn.models.``CdnEndpoint`(*, id: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Defines the ARM Resource ID for the linked endpoints.

  Parameters: | id (str) – ARM Resource ID string.

class `azure.mgmt.cdn.models.``CdnManagedHttpsParameters`(*, protocol_type, certificate_source_parameters, minimum_tls_version=None, **kwargs)

  Bases: `azure.mgmt.cdn.models._models_py3.CustomDomainHttpsParameters`

  Defines the certificate source parameters using CDN managed certificate for enabling SSL.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - protocol_type (str or ProtocolType) – Required. Defines the TLS extension protocol that is used for secure delivery. Possible values include: ‘ServerNameIndication’, ‘IPBased’
  - minimum_tls_version (str or MinimumTlsVersion) – TLS protocol version that will be used for Https. Possible values include: ‘None’, ‘TLS10’, ‘TLS12’
  - certificate_source (str) – Required. Constant filled by server.
  - certificate_source_parameters (CdnCertificateSourceParameters) – Required. Defines the certificate source parameters using CDN managed certificate for enabling SSL.

class `azure.mgmt.cdn.models.``CdnWebApplicationFirewallPolicy`(*, location: str, sku, tags=None, policy_settings=None, rate_limit_rules=None, custom_rules=None, managed_rules=None, etag: str = None, **kwargs)

  Bases: `azure.mgmt.cdn.models._models_py3.TrackedResource`

  Defines web application firewall policy for Azure CDN.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables:

  - id (str) – Resource ID.
  - name (str) – Resource name.
  - type (str) – Resource type.
  - endpoint_links (list[CdnEndpoint]) – Describes Azure CDN endpoints associated with this Web Application Firewall policy.
  - provisioning_state (str or ProvisioningState) – Provisioning state of the WebApplicationFirewallPolicy. Possible values include: ‘Creating’, ‘Succeeded’, ‘Failed’
  - resource_state (str or PolicyResourceState) – Resource status of the policy. Possible values include: ‘Creating’, ‘Enabling’, ‘Enabled’, ‘Disabling’, ‘Disabled’, ‘Deleting’

  Parameters:

  - location (str) – Required. Resource location.
  - tags (dict[str, str]) – Resource tags.
  - policy_settings (PolicySettings) – Describes policySettings for policy
  - rate_limit_rules (RateLimitRuleList) – Describes rate limit rules inside the policy.
  - custom_rules (CustomRuleList) – Describes custom rules inside the policy.
  - managed_rules (ManagedRuleSetList) – Describes managed rules inside the policy.
  - etag (str) – Gets a unique read-only string that changes whenever the resource is updated.
  - sku (Sku) – Required. The pricing tier (defines a CDN provider, feature list and rate) of the CdnWebApplicationFirewallPolicy.

class `azure.mgmt.cdn.models.``CdnWebApplicationFirewallPolicyPatchParameters`(*, tags=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties required to update a CdnWebApplicationFirewallPolicy.

  Parameters: | tags (dict[str, str]) – CdnWebApplicationFirewallPolicy tags

class `azure.mgmt.cdn.models.``CheckNameAvailabilityInput`(*, name: str, **kwargs)

  Bases: `msrest.serialization.Model`

  Input of CheckNameAvailability API.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Parameters: | name (str) – Required. The resource name to validate.
  Variables: | type (str) – Required. The type of the resource whose name is to be validated. Default value: “Microsoft.Cdn/Profiles/Endpoints” .

  `type` = 'Microsoft.Cdn/Profiles/Endpoints'

class `azure.mgmt.cdn.models.``CheckNameAvailabilityOutput`(**kwargs)

  Bases: `msrest.serialization.Model`

  Output of check name availability API.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - name_available (bool) – Indicates whether the name is available.
  - reason (str) – The reason why the name is not available.
  - message (str) – The detailed error message describing why the name is not available.

class `azure.mgmt.cdn.models.``CidrIpAddress`(*, base_ip_address: str = None, prefix_length: int = None, **kwargs)

  Bases: `msrest.serialization.Model`

  CIDR Ip address.

  Parameters:

  - base_ip_address (str) – Ip address itself.
  - prefix_length (int) – The length of the prefix of the ip address.

class `azure.mgmt.cdn.models.``CookiesMatchConditionParameters`(*, selector: str, operator, match_values, negate_condition: bool = None, transforms=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Defines the parameters for Cookies match conditions.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables: | odatatype (str) – Required. Default value: “#Microsoft.Azure.Cdn.Models.DeliveryRuleCookiesConditionParameters” .

  Parameters:

  - selector (str) – Required. Name of Cookies to be matched
  - operator (str or CookiesOperator) – Required. Describes operator to be matched. Possible values include: ‘Any’, ‘Equal’, ‘Contains’, ‘BeginsWith’, ‘EndsWith’, ‘LessThan’, ‘LessThanOrEqual’, ‘GreaterThan’, ‘GreaterThanOrEqual’
  - negate_condition (bool) – Describes if this is negate condition or not
  - match_values (list[str]) – Required. The match value for the condition of the delivery rule
  - transforms (list[str or Transform]) – List of transforms

  `odatatype` = '#Microsoft.Azure.Cdn.Models.DeliveryRuleCookiesConditionParameters'

class `azure.mgmt.cdn.models.``CustomDomain`(*, host_name: str, custom_https_parameters=None, validation_data: str = None, **kwargs)

  Bases: `azure.mgmt.cdn.models._models_py3.ProxyResource`

  Friendly domain name mapping to the endpoint hostname that the customer provides for branding purposes, e.g. www.contoso.com.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables:

  - id (str) – Resource ID.
  - name (str) – Resource name.
  - type (str) – Resource type.
  - resource_state (str or CustomDomainResourceState) – Resource status of the custom domain. Possible values include: ‘Creating’, ‘Active’, ‘Deleting’
  - custom_https_provisioning_state (str or CustomHttpsProvisioningState) – Provisioning status of Custom Https of the custom domain. Possible values include: ‘Enabling’, ‘Enabled’, ‘Disabling’, ‘Disabled’, ‘Failed’
  - custom_https_provisioning_substate (str or CustomHttpsProvisioningSubstate) – Provisioning substate shows the progress of custom HTTPS enabling/disabling process step by step. Possible values include: ‘SubmittingDomainControlValidationRequest’, ‘PendingDomainControlValidationREquestApproval’, ‘DomainControlValidationRequestApproved’, ‘DomainControlValidationRequestRejected’, ‘DomainControlValidationRequestTimedOut’, ‘IssuingCertificate’, ‘DeployingCertificate’, ‘CertificateDeployed’, ‘DeletingCertificate’, ‘CertificateDeleted’
  - provisioning_state (str) – Provisioning status of the custom domain.

  Parameters:

  - host_name (str) – Required. The host name of the custom domain. Must be a domain name.
  - custom_https_parameters (CustomDomainHttpsParameters) – Certificate parameters for securing custom HTTPS
  - validation_data (str) – Special validation or data may be required when delivering CDN to some regions due to local compliance reasons. E.g. ICP license number of a custom domain is required to deliver content in China.

class `azure.mgmt.cdn.models.``CustomDomainHttpsParameters`(*, protocol_type, minimum_tls_version=None, **kwargs)

  Bases: `msrest.serialization.Model`

  The JSON object that contains the properties to secure a custom domain.

  You probably want to use the sub-classes and not this class directly. Known sub-classes are: CdnManagedHttpsParameters, UserManagedHttpsParameters

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - protocol_type (str or ProtocolType) – Required. Defines the TLS extension protocol that is used for secure delivery. Possible values include: ‘ServerNameIndication’, ‘IPBased’
  - minimum_tls_version (str or MinimumTlsVersion) – TLS protocol version that will be used for Https. Possible values include: ‘None’, ‘TLS10’, ‘TLS12’
  - certificate_source (str) – Required. Constant filled by server.

class `azure.mgmt.cdn.models.``CustomDomainParameters`(*, host_name: str, **kwargs)

  Bases: `msrest.serialization.Model`

  The customDomain JSON object required for custom domain creation or update.

  All required parameters must be populated in order to send to Azure.

  Parameters: | host_name (str) – Required. The host name of the custom domain. Must be a domain name.

class `azure.mgmt.cdn.models.``CustomRule`(*, name: str, priority: int, match_conditions, action, enabled_state=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Defines the common attributes for a custom rule that can be included in a waf policy.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - name (str) – Required. Defines the name of the custom rule
  - enabled_state (str or CustomRuleEnabledState) – Describes if the custom rule is in enabled or disabled state. Defaults to Enabled if not specified. Possible values include: ‘Disabled’, ‘Enabled’
  - priority (int) – Required. Defines in what order this rule be evaluated in the overall list of custom rules
  - match_conditions (list[MatchCondition]) – Required. List of match conditions.
  - action (str or ActionType) – Required. Describes what action to be applied when rule matches. Possible values include: ‘Allow’, ‘Block’, ‘Log’, ‘Redirect’

class `azure.mgmt.cdn.models.``CustomRuleList`(*, rules=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Defines contents of custom rules.

  Parameters: | rules (list[CustomRule]) – List of rules

class `azure.mgmt.cdn.models.``DeepCreatedOrigin`(*, name: str, host_name: str, http_port: int = None, https_port: int = None, **kwargs)

  Bases: `msrest.serialization.Model`

  The main origin of CDN content which is added when creating a CDN endpoint.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - name (str) – Required. Origin name
  - host_name (str) – Required. The address of the origin. It can be a domain name, IPv4 address, or IPv6 address.
  - http_port (int) – The value of the HTTP port. Must be between 1 and 65535
  - https_port (int) – The value of the HTTPS port. Must be between 1 and 65535

class `azure.mgmt.cdn.models.``DeliveryRule`(*, order: int, actions, name: str = None, conditions=None, **kwargs)

  Bases: `msrest.serialization.Model`

  A rule that specifies a set of actions and conditions.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - name (str) – Name of the rule
  - order (int) – Required. The order in which the rules are applied for the endpoint. Possible values {0,1,2,3,………}. A rule with a lesser order will be applied before a rule with a greater order. Rule with order 0 is a special rule. It does not require any condition and actions listed in it will always be applied.
  - conditions (list[DeliveryRuleCondition]) – A list of conditions that must be matched for the actions to be executed
  - actions (list[DeliveryRuleAction]) – Required. A list of actions that are executed when all the conditions of a rule are satisfied.

class `azure.mgmt.cdn.models.``DeliveryRuleAction`(**kwargs)

  Bases: `msrest.serialization.Model`

  An action for the delivery rule.

  You probably want to use the sub-classes and not this class directly. Known sub-classes are: UrlRedirectAction, UrlRewriteAction, DeliveryRuleRequestHeaderAction, DeliveryRuleResponseHeaderAction, DeliveryRuleCacheExpirationAction, DeliveryRuleCacheKeyQueryStringAction

  All required parameters must be populated in order to send to Azure.

  Parameters: | name (str) – Required. Constant filled by server.

class `azure.mgmt.cdn.models.``DeliveryRuleCacheExpirationAction`(*, parameters, **kwargs)

  Bases: `azure.mgmt.cdn.models._models_py3.DeliveryRuleAction`

  Defines the cache expiration action for the delivery rule.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - name (str) – Required. Constant filled by server.
  - parameters (CacheExpirationActionParameters) – Required. Defines the parameters for the action.

class `azure.mgmt.cdn.models.``DeliveryRuleCacheKeyQueryStringAction`(*, parameters, **kwargs)

  Bases: `azure.mgmt.cdn.models._models_py3.DeliveryRuleAction`

  Defines the cache-key query string action for the delivery rule.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - name (str) – Required. Constant filled by server.
  - parameters (CacheKeyQueryStringActionParameters) – Required. Defines the parameters for the action.

class `azure.mgmt.cdn.models.``DeliveryRuleCondition`(**kwargs)

  Bases: `msrest.serialization.Model`

  A condition for the delivery rule.

  You probably want to use the sub-classes and not this class directly. Known sub-classes are: DeliveryRuleRemoteAddressCondition, DeliveryRuleRequestMethodCondition, DeliveryRuleQueryStringCondition, DeliveryRulePostArgsCondition, DeliveryRuleRequestUriCondition, DeliveryRuleRequestHeaderCondition, DeliveryRuleRequestBodyCondition, DeliveryRuleRequestSchemeCondition, DeliveryRuleUrlPathCondition, DeliveryRuleUrlFileExtensionCondition, DeliveryRuleUrlFileNameCondition, DeliveryRuleHttpVersionCondition, DeliveryRuleCookiesCondition, DeliveryRuleIsDeviceCondition

  All required parameters must be populated in order to send to Azure.

  Parameters: | name (str) – Required. Constant filled by server.

class `azure.mgmt.cdn.models.``DeliveryRuleCookiesCondition`(*, parameters, **kwargs)

  Bases: `azure.mgmt.cdn.models._models_py3.DeliveryRuleCondition`

  Defines the Cookies condition for the delivery rule.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - name (str) – Required. Constant filled by server.
  - parameters (CookiesMatchConditionParameters) – Required. Defines the parameters for the condition.

class `azure.mgmt.cdn.models.``DeliveryRuleHttpVersionCondition`(*, parameters, **kwargs)

  Bases: `azure.mgmt.cdn.models._models_py3.DeliveryRuleCondition`

  Defines the HttpVersion condition for the delivery rule.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - name (str) – Required. Constant filled by server.
  - parameters (HttpVersionMatchConditionParameters) – Required. Defines the parameters for the condition.

class `azure.mgmt.cdn.models.``DeliveryRuleIsDeviceCondition`(*, parameters, **kwargs)

  Bases: `azure.mgmt.cdn.models._models_py3.DeliveryRuleCondition`

  Defines the IsDevice condition for the delivery rule.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - name (str) – Required. Constant filled by server.
  - parameters (IsDeviceMatchConditionParameters) – Required. Defines the parameters for the condition.

class `azure.mgmt.cdn.models.``DeliveryRulePostArgsCondition`(*, parameters, **kwargs)

  Bases: `azure.mgmt.cdn.models._models_py3.DeliveryRuleCondition`

  Defines the PostArgs condition for the delivery rule.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - name (str) – Required. Constant filled by server.
  - parameters (PostArgsMatchConditionParameters) – Required. Defines the parameters for the condition.

class `azure.mgmt.cdn.models.``DeliveryRuleQueryStringCondition`(*, parameters, **kwargs)

  Bases: `azure.mgmt.cdn.models._models_py3.DeliveryRuleCondition`

  Defines the QueryString condition for the delivery rule.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - name (str) – Required. Constant filled by server.
  - parameters (QueryStringMatchConditionParameters) – Required. Defines the parameters for the condition.

class `azure.mgmt.cdn.models.``DeliveryRuleRemoteAddressCondition`(*, parameters, **kwargs)

  Bases: `azure.mgmt.cdn.models._models_py3.DeliveryRuleCondition`

  Defines the RemoteAddress condition for the delivery rule.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - name (str) – Required. Constant filled by server.
  - parameters (RemoteAddressMatchConditionParameters) – Required. Defines the parameters for the condition.

class `azure.mgmt.cdn.models.``DeliveryRuleRequestBodyCondition`(*, parameters, **kwargs)

  Bases: `azure.mgmt.cdn.models._models_py3.DeliveryRuleCondition`

  Defines the RequestBody condition for the delivery rule.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - name (str) – Required. Constant filled by server.
  - parameters (RequestBodyMatchConditionParameters) – Required. Defines the parameters for the condition.

class `azure.mgmt.cdn.models.``DeliveryRuleRequestHeaderAction`(*, parameters, **kwargs)

  Bases: `azure.mgmt.cdn.models._models_py3.DeliveryRuleAction`

  Defines the request header action for the delivery rule.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - name (str) – Required. Constant filled by server.
  - parameters (HeaderActionParameters) – Required. Defines the parameters for the action.

class `azure.mgmt.cdn.models.``DeliveryRuleRequestHeaderCondition`(*, parameters, **kwargs)

  Bases: `azure.mgmt.cdn.models._models_py3.DeliveryRuleCondition`

  Defines the RequestHeader condition for the delivery rule.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - name (str) – Required. Constant filled by server.
  - parameters (RequestHeaderMatchConditionParameters) – Required. Defines the parameters for the condition.

class `azure.mgmt.cdn.models.``DeliveryRuleRequestMethodCondition`(*, parameters, **kwargs)

  Bases: `azure.mgmt.cdn.models._models_py3.DeliveryRuleCondition`

  Defines the RequestMethod condition for the delivery rule.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - name (str) – Required. Constant filled by server.
  - parameters (RequestMethodMatchConditionParameters) – Required. Defines the parameters for the condition.

class `azure.mgmt.cdn.models.``DeliveryRuleRequestSchemeCondition`(*, parameters, **kwargs)

  Bases: `azure.mgmt.cdn.models._models_py3.DeliveryRuleCondition`

  Defines the RequestScheme condition for the delivery rule.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - name (str) – Required. Constant filled by server.
  - parameters (RequestSchemeMatchConditionParameters) – Required. Defines the parameters for the condition.

class `azure.mgmt.cdn.models.``DeliveryRuleRequestUriCondition`(*, parameters, **kwargs)

  Bases: `azure.mgmt.cdn.models._models_py3.DeliveryRuleCondition`

  Defines the RequestUri condition for the delivery rule.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - name (str) – Required. Constant filled by server.
  - parameters (RequestUriMatchConditionParameters) – Required. Defines the parameters for the condition.

class `azure.mgmt.cdn.models.``DeliveryRuleResponseHeaderAction`(*, parameters, **kwargs)

  Bases: `azure.mgmt.cdn.models._models_py3.DeliveryRuleAction`

  Defines the response header action for the delivery rule.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - name (str) – Required. Constant filled by server.
  - parameters (HeaderActionParameters) – Required. Defines the parameters for the action.

class `azure.mgmt.cdn.models.``DeliveryRuleUrlFileExtensionCondition`(*, parameters, **kwargs)

  Bases: `azure.mgmt.cdn.models._models_py3.DeliveryRuleCondition`

  Defines the UrlFileExtension condition for the delivery rule.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - name (str) – Required. Constant filled by server.
  - parameters (UrlFileExtensionMatchConditionParameters) – Required. Defines the parameters for the condition.

class `azure.mgmt.cdn.models.``DeliveryRuleUrlFileNameCondition`(*, parameters, **kwargs)

  Bases: `azure.mgmt.cdn.models._models_py3.DeliveryRuleCondition`

  Defines the UrlFileName condition for the delivery rule.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - name (str) – Required. Constant filled by server.
  - parameters (UrlFileNameMatchConditionParameters) – Required. Defines the parameters for the condition.

class `azure.mgmt.cdn.models.``DeliveryRuleUrlPathCondition`(*, parameters, **kwargs)

  Bases: `azure.mgmt.cdn.models._models_py3.DeliveryRuleCondition`

  Defines the UrlPath condition for the delivery rule.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - name (str) – Required. Constant filled by server.
  - parameters (UrlPathMatchConditionParameters) – Required. Defines the parameters for the condition.

class `azure.mgmt.cdn.models.``EdgeNode`(*, ip_address_groups, **kwargs)

  Bases: `azure.mgmt.cdn.models._models_py3.ProxyResource`

  Edgenode is a global Point of Presence (POP) location used to deliver CDN content to end users.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables:

  - id (str) – Resource ID.
  - name (str) – Resource name.
  - type (str) – Resource type.

  Parameters: | ip_address_groups (list[IpAddressGroup]) – Required. List of ip address groups.

class `azure.mgmt.cdn.models.``Endpoint`(*, location: str, origins, tags=None, origin_host_header: str = None, origin_path: str = None, content_types_to_compress=None, is_compression_enabled: bool = None, is_http_allowed: bool = None, is_https_allowed: bool = None, query_string_caching_behavior=None, optimization_type=None, probe_path: str = None, geo_filters=None, delivery_policy=None, web_application_firewall_policy_link=None, **kwargs)

  Bases: `azure.mgmt.cdn.models._models_py3.TrackedResource`

  CDN endpoint is the entity within a CDN profile containing configuration information such as origin, protocol, content caching and delivery behavior. The CDN endpoint uses the URL format <endpointname>.azureedge.net.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables:

  - id (str) – Resource ID.
  - name (str) – Resource name.
  - type (str) – Resource type.
  - host_name (str) – The host name of the endpoint structured as {endpointName}.{DNSZone}, e.g. contoso.azureedge.net
  - resource_state (str or EndpointResourceState) – Resource status of the endpoint. Possible values include: ‘Creating’, ‘Deleting’, ‘Running’, ‘Starting’, ‘Stopped’, ‘Stopping’
  - provisioning_state (str) – Provisioning status of the endpoint.

  Parameters:

  - location (str) – Required. Resource location.
  - tags (dict[str, str]) – Resource tags.
  - origin_host_header (str) – The host header value sent to the origin with each request. If you leave this blank, the request hostname determines this value. Azure CDN origins, such as Web Apps, Blob Storage, and Cloud Services require this host header value to match the origin hostname by default.
  - origin_path (str) – A directory path on the origin that CDN can use to retrieve content from, e.g. contoso.cloudapp.net/originpath.
  - content_types_to_compress (list[str]) – List of content types on which compression applies. The value should be a valid MIME type.
  - is_compression_enabled (bool) – Indicates whether content compression is enabled on CDN. Default value is false. If compression is enabled, content will be served as compressed if user requests for a compressed version. Content won’t be compressed on CDN when requested content is smaller than 1 byte or larger than 1 MB.
  - is_http_allowed (bool) – Indicates whether HTTP traffic is allowed on the endpoint. Default value is true. At least one protocol (HTTP or HTTPS) must be allowed.
  - is_https_allowed (bool) – Indicates whether HTTPS traffic is allowed on the endpoint. Default value is true. At least one protocol (HTTP or HTTPS) must be allowed.
  - query_string_caching_behavior (str or QueryStringCachingBehavior) – Defines how CDN caches requests that include query strings. You can ignore any query strings when caching, bypass caching to prevent requests that contain query strings from being cached, or cache every request with a unique URL. Possible values include: ‘IgnoreQueryString’, ‘BypassCaching’, ‘UseQueryString’, ‘NotSet’
  - optimization_type (str or OptimizationType) – Specifies what scenario the customer wants this CDN endpoint to optimize for, e.g. Download, Media services. With this information, CDN can apply scenario driven optimization. Possible values include: ‘GeneralWebDelivery’, ‘GeneralMediaStreaming’, ‘VideoOnDemandMediaStreaming’, ‘LargeFileDownload’, ‘DynamicSiteAcceleration’
  - probe_path (str) – Path to a file hosted on the origin which helps accelerate delivery of the dynamic content and calculate the most optimal routes for the CDN. This is relative to the origin path.
  - geo_filters (list[GeoFilter]) – List of rules defining the user’s geo access within a CDN endpoint. Each geo filter defines an access rule to a specified path or content, e.g. block APAC for path /pictures/
  - delivery_policy (EndpointPropertiesUpdateParametersDeliveryPolicy) – A policy that specifies the delivery rules to be used for an endpoint.
  - web_application_firewall_policy_link (EndpointPropertiesUpdateParametersWebApplicationFirewallPolicyLink) – Defines the Web Application Firewall policy for the endpoint (if applicable)
  - origins (list[DeepCreatedOrigin]) – Required. The source of the content being delivered via CDN.

class `azure.mgmt.cdn.models.``EndpointPropertiesUpdateParametersDeliveryPolicy`(*, rules, description: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  A policy that specifies the delivery rules to be used for an endpoint.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - description (str) – User-friendly description of the policy.
  - rules (list[DeliveryRule]) – Required. A list of the delivery rules.

class `azure.mgmt.cdn.models.``EndpointPropertiesUpdateParametersWebApplicationFirewallPolicyLink`(*, id: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Defines the Web Application Firewall policy for the endpoint (if applicable).

  Parameters: | id (str) – Resource ID.

class `azure.mgmt.cdn.models.``EndpointUpdateParameters`(*, tags=None, origin_host_header: str = None, origin_path: str = None, content_types_to_compress=None, is_compression_enabled: bool = None, is_http_allowed: bool = None, is_https_allowed: bool = None, query_string_caching_behavior=None, optimization_type=None, probe_path: str = None, geo_filters=None, delivery_policy=None, web_application_firewall_policy_link=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties required to create or update an endpoint.

  Parameters:

  - tags (dict[str, str]) – Endpoint tags.
  - origin_host_header (str) – The host header value sent to the origin with each request. If you leave this blank, the request hostname determines this value. Azure CDN origins, such as Web Apps, Blob Storage, and Cloud Services require this host header value to match the origin hostname by default.
  - origin_path (str) – A directory path on the origin that CDN can use to retrieve content from, e.g. contoso.cloudapp.net/originpath.
  - content_types_to_compress (list[str]) – List of content types on which compression applies. The value should be a valid MIME type.
  - is_compression_enabled (bool) – Indicates whether content compression is enabled on CDN. Default value is false. If compression is enabled, content will be served as compressed if user requests for a compressed version. Content won’t be compressed on CDN when requested content is smaller than 1 byte or larger than 1 MB.
  - is_http_allowed (bool) – Indicates whether HTTP traffic is allowed on the endpoint. Default value is true. At least one protocol (HTTP or HTTPS) must be allowed.
  - is_https_allowed (bool) – Indicates whether HTTPS traffic is allowed on the endpoint. Default value is true. At least one protocol (HTTP or HTTPS) must be allowed.
  - query_string_caching_behavior (str or QueryStringCachingBehavior) – Defines how CDN caches requests that include query strings. You can ignore any query strings when caching, bypass caching to prevent requests that contain query strings from being cached, or cache every request with a unique URL. Possible values include: ‘IgnoreQueryString’, ‘BypassCaching’, ‘UseQueryString’, ‘NotSet’
  - optimization_type (str or OptimizationType) – Specifies what scenario the customer wants this CDN endpoint to optimize for, e.g. Download, Media services. With this information, CDN can apply scenario driven optimization. Possible values include: ‘GeneralWebDelivery’, ‘GeneralMediaStreaming’, ‘VideoOnDemandMediaStreaming’, ‘LargeFileDownload’, ‘DynamicSiteAcceleration’
  - probe_path (str) – Path to a file hosted on the origin which helps accelerate delivery of the dynamic content and calculate the most optimal routes for the CDN. This is relative to the origin path.
  - geo_filters (list[GeoFilter]) – List of rules defining the user’s geo access within a CDN endpoint. Each geo filter defines an access rule to a specified path or content, e.g. block APAC for path /pictures/
  - delivery_policy (EndpointPropertiesUpdateParametersDeliveryPolicy) – A policy that specifies the delivery rules to be used for an endpoint.
  - web_application_firewall_policy_link (EndpointPropertiesUpdateParametersWebApplicationFirewallPolicyLink) – Defines the Web Application Firewall policy for the endpoint (if applicable)

class `azure.mgmt.cdn.models.``ErrorResponse`(**kwargs)

  Bases: `msrest.serialization.Model`

  Error response indicates CDN service is not able to process the incoming request. The reason is provided in the error message.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - code (str) – Error code.
  - message (str) – Error message indicating why the operation failed.

class `azure.mgmt.cdn.models.``GeoFilter`(*, relative_path: str, action, country_codes, **kwargs)

  Bases: `msrest.serialization.Model`

  Rules defining user’s geo access within a CDN endpoint.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - relative_path (str) – Required. Relative path applicable to geo filter. (e.g. ‘/mypictures’, ‘/mypicture/kitty.jpg’, and etc.)
  - action (str or GeoFilterActions) – Required. Action of the geo filter, i.e. allow or block access. Possible values include: ‘Block’, ‘Allow’
  - country_codes (list[str]) – Required. Two letter country codes defining user country access in a geo filter, e.g. AU, MX, US.

class `azure.mgmt.cdn.models.``HeaderActionParameters`(*, header_action, header_name: str, value: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Defines the parameters for the request header action.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables: | odatatype (str) – Required. Default value: “#Microsoft.Azure.Cdn.Models.DeliveryRuleHeaderActionParameters” .

  Parameters:

  - header_action (str or HeaderAction) – Required. Action to perform. Possible values include: ‘Append’, ‘Overwrite’, ‘Delete’
  - header_name (str) – Required. Name of the header to modify
  - value (str) – Value for the specified action

  `odatatype` = '#Microsoft.Azure.Cdn.Models.DeliveryRuleHeaderActionParameters'

class `azure.mgmt.cdn.models.``HttpVersionMatchConditionParameters`(*, match_values, negate_condition: bool = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Defines the parameters for HttpVersion match conditions.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables:

  - odatatype (str) – Required. Default value: “#Microsoft.Azure.Cdn.Models.DeliveryRuleHttpVersionConditionParameters” .
  - operator (str) – Required. Describes operator to be matched. Default value: “Equal” .

  Parameters:

  - negate_condition (bool) – Describes if this is negate condition or not
  - match_values (list[str]) – Required. The match value for the condition of the delivery rule

  `odatatype` = '#Microsoft.Azure.Cdn.Models.DeliveryRuleHttpVersionConditionParameters'
  `operator` = 'Equal'

class `azure.mgmt.cdn.models.``IpAddressGroup`(*, delivery_region: str = None, ipv4_addresses=None, ipv6_addresses=None, **kwargs)

  Bases: `msrest.serialization.Model`

  CDN Ip address group.

  Parameters:

  - delivery_region (str) – The delivery region of the ip address group
  - ipv4_addresses (list[CidrIpAddress]) – The list of ip v4 addresses.
  - ipv6_addresses (list[CidrIpAddress]) – The list of ip v6 addresses.

class `azure.mgmt.cdn.models.``IsDeviceMatchConditionParameters`(*, match_values, negate_condition: bool = None, transforms=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Defines the parameters for IsDevice match conditions.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables:

  - odatatype (str) – Required. Default value: “#Microsoft.Azure.Cdn.Models.DeliveryRuleIsDeviceConditionParameters” .
  - operator (str) – Required. Describes operator to be matched. Default value: “Equal” .

  Parameters:

  - negate_condition (bool) – Describes if this is negate condition or not
  - match_values (list[str]) – Required. The match value for the condition of the delivery rule
  - transforms (list[str or Transform]) – List of transforms

  `odatatype` = '#Microsoft.Azure.Cdn.Models.DeliveryRuleIsDeviceConditionParameters'
  `operator` = 'Equal'

class `azure.mgmt.cdn.models.``KeyVaultCertificateSourceParameters`(*, subscription_id: str, resource_group_name: str, vault_name: str, secret_name: str, secret_version: str, **kwargs)

  Bases: `msrest.serialization.Model`

  Describes the parameters for using a user’s KeyVault certificate for securing custom domain.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables:

  - odatatype (str) – Required. Default value: “#Microsoft.Azure.Cdn.Models.KeyVaultCertificateSourceParameters” .
  - update_rule (str) – Required. Describes the action that shall be taken when the certificate is updated in Key Vault. Default value: “NoAction” .
  - delete_rule (str) – Required. Describes the action that shall be taken when the certificate is removed from Key Vault. Default value: “NoAction” .

  Parameters:

  - subscription_id (str) – Required. Subscription Id of the user’s Key Vault containing the SSL certificate
  - resource_group_name (str) – Required. Resource group of the user’s Key Vault containing the SSL certificate
  - vault_name (str) – Required. The name of the user’s Key Vault containing the SSL certificate
  - secret_name (str) – Required. The name of Key Vault Secret (representing the full certificate PFX) in Key Vault.
  - secret_version (str) – Required. The version(GUID) of Key Vault Secret in Key Vault.

  `delete_rule` = 'NoAction'
  `odatatype` = '#Microsoft.Azure.Cdn.Models.KeyVaultCertificateSourceParameters'
  `update_rule` = 'NoAction'

class `azure.mgmt.cdn.models.``LoadParameters`(*, content_paths, **kwargs)

  Bases: `msrest.serialization.Model`

  Parameters required for content load.

  All required parameters must be populated in order to send to Azure.

  Parameters: | content_paths (list[str]) – Required. The path to the content to be loaded. Path should be a relative file URL of the origin.

class `azure.mgmt.cdn.models.``ManagedRuleDefinition`(**kwargs)

  Bases: `msrest.serialization.Model`

  Describes a managed rule definition.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - rule_id (str) – Identifier for the managed rule.
  - description (str) – Describes the functionality of the managed rule.

class `azure.mgmt.cdn.models.``ManagedRuleGroupDefinition`(**kwargs)

  Bases: `msrest.serialization.Model`

  Describes a managed rule group.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - rule_group_name (str) – Name of the managed rule group.
  - description (str) – Description of the managed rule group.
  - rules (list[ManagedRuleDefinition]) – List of rules within the managed rule group.

class `azure.mgmt.cdn.models.``ManagedRuleGroupOverride`(*, rule_group_name: str, rules=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Defines a managed rule group override setting.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - rule_group_name (str) – Required. Describes the managed rule group within the rule set to override
  - rules (list[ManagedRuleOverride]) – List of rules that will be disabled. If none specified, all rules in the group will be disabled.

class `azure.mgmt.cdn.models.``ManagedRuleOverride`(*, rule_id: str, enabled_state=None, action=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Defines a managed rule group override setting.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - rule_id (str) – Required. Identifier for the managed rule.
  - enabled_state (str or ManagedRuleEnabledState) – Describes if the managed rule is in enabled or disabled state. Defaults to Disabled if not specified. Possible values include: ‘Disabled’, ‘Enabled’
  - action (str or ActionType) – Describes the override action to be applied when rule matches. Possible values include: ‘Allow’, ‘Block’, ‘Log’, ‘Redirect’

class `azure.mgmt.cdn.models.``ManagedRuleSet`(*, rule_set_type: str, rule_set_version: str, anomaly_score: int = None, rule_group_overrides=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Defines a managed rule set.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - rule_set_type (str) – Required. Defines the rule set type to use.
  - rule_set_version (str) – Required. Defines the version of the rule set to use.
  - anomaly_score (int) – Verizon only : If the rule set supports anomaly detection mode, this describes the threshold for blocking requests.
  - rule_group_overrides (list[ManagedRuleGroupOverride]) – Defines the rule overrides to apply to the rule set.

class `azure.mgmt.cdn.models.``ManagedRuleSetDefinition`(*, sku=None, **kwargs)

  Bases: `azure.mgmt.cdn.models._models_py3.Resource`

  Describes a managed rule set definition.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - id (str) – Resource ID.
  - name (str) – Resource name.
  - type (str) – Resource type.
  - provisioning_state (str) – Provisioning state of the managed rule set.
  - rule_set_type (str) – Type of the managed rule set.
  - rule_set_version (str) – Version of the managed rule set type.
  - rule_groups (list[ManagedRuleGroupDefinition]) – Rule groups of the managed rule set.

  Parameters: | sku (Sku) – The pricing tier (defines a CDN provider, feature list and rate) of the CdnWebApplicationFirewallPolicy.

class `azure.mgmt.cdn.models.``ManagedRuleSetList`(*, managed_rule_sets=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Defines the list of managed rule sets for the policy.

  Parameters: | managed_rule_sets (list[ManagedRuleSet]) – List of rule sets.

class `azure.mgmt.cdn.models.``MatchCondition`(*, match_variable, operator, match_value, selector: str = None, negate_condition: bool = None, transforms=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Define match conditions.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - match_variable (str or MatchVariable) – Required. Match variable to compare against. Possible values include: ‘RemoteAddr’, ‘Country’, ‘RequestMethod’, ‘RequestHeader’, ‘RequestUri’, ‘QueryString’, ‘RequestBody’, ‘Cookies’, ‘PostArgs’
  - selector (str) – Selector can used to match a specific key for QueryString, RequestUri, RequestHeaders or RequestBody.
  - operator (str or Operator) – Required. Describes operator to be matched. Possible values include: ‘Any’, ‘IPMatch’, ‘GeoMatch’, ‘Equal’, ‘Contains’, ‘LessThan’, ‘GreaterThan’, ‘LessThanOrEqual’, ‘GreaterThanOrEqual’, ‘BeginsWith’, ‘EndsWith’, ‘RegEx’
  - negate_condition (bool) – Describes if the result of this condition should be negated.
  - match_value (list[str]) – Required. List of possible match values.
  - transforms (list[str or TransformType]) – List of transforms.

class `azure.mgmt.cdn.models.``Operation`(*, display=None, **kwargs)

  Bases: `msrest.serialization.Model`

  CDN REST API operation.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables: | name (str) – Operation name: {provider}/{resource}/{operation}
  Parameters: | display (OperationDisplay) – The object that represents the operation.

class `azure.mgmt.cdn.models.``OperationDisplay`(**kwargs)

  Bases: `msrest.serialization.Model`

  The object that represents the operation.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - provider (str) – Service provider: Microsoft.Cdn
  - resource (str) – Resource on which the operation is performed: Profile, endpoint, etc.
  - operation (str) – Operation type: Read, write, delete, etc.

class `azure.mgmt.cdn.models.``Origin`(*, location: str, host_name: str, tags=None, http_port: int = None, https_port: int = None, **kwargs)

  Bases: `azure.mgmt.cdn.models._models_py3.TrackedResource`

  CDN origin is the source of the content being delivered via CDN. When the edge nodes represented by an endpoint do not have the requested content cached, they attempt to fetch it from one or more of the configured origins.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables:

  - id (str) – Resource ID.
  - name (str) – Resource name.
  - type (str) – Resource type.
  - resource_state (str or OriginResourceState) – Resource status of the origin. Possible values include: ‘Creating’, ‘Active’, ‘Deleting’
  - provisioning_state (str) – Provisioning status of the origin.

  Parameters:

  - location (str) – Required. Resource location.
  - tags (dict[str, str]) – Resource tags.
  - host_name (str) – Required. The address of the origin. Domain names, IPv4 addresses, and IPv6 addresses are supported.
  - http_port (int) – The value of the HTTP port. Must be between 1 and 65535.
  - https_port (int) – The value of the https port. Must be between 1 and 65535.

class `azure.mgmt.cdn.models.``OriginUpdateParameters`(*, host_name: str = None, http_port: int = None, https_port: int = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Origin properties needed for origin creation or update.

  Parameters:

  - host_name (str) – The address of the origin. Domain names, IPv4 addresses, and IPv6 addresses are supported.
  - http_port (int) – The value of the HTTP port. Must be between 1 and 65535.
  - https_port (int) – The value of the HTTPS port. Must be between 1 and 65535.

class `azure.mgmt.cdn.models.``PolicySettings`(*, enabled_state=None, mode=None, default_redirect_url: str = None, default_custom_block_response_status_code: int = None, default_custom_block_response_body: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Defines contents of a web application firewall global configuration.

  Parameters:

  - enabled_state (str or PolicyEnabledState) – describes if the policy is in enabled state or disabled state. Possible values include: ‘Disabled’, ‘Enabled’
  - mode (str or PolicyMode) – Describes if it is in detection mode or prevention mode at policy level. Possible values include: ‘Prevention’, ‘Detection’
  - default_redirect_url (str) – If action type is redirect, this field represents the default redirect URL for the client.
  - default_custom_block_response_status_code (int) – If the action type is block, this field defines the default customer overridable http response status code.
  - default_custom_block_response_body (str) – If the action type is block, customer can override the response body. The body must be specified in base64 encoding.

class `azure.mgmt.cdn.models.``PostArgsMatchConditionParameters`(*, selector: str, operator, match_values, negate_condition: bool = None, transforms=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Defines the parameters for PostArgs match conditions.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables: | odatatype (str) – Required. Default value: “#Microsoft.Azure.Cdn.Models.DeliveryRulePostArgsConditionParameters” .

  Parameters:

  - selector (str) – Required. Name of PostArg to be matched
  - operator (str or PostArgsOperator) – Required. Describes operator to be matched. Possible values include: ‘Any’, ‘Equal’, ‘Contains’, ‘BeginsWith’, ‘EndsWith’, ‘LessThan’, ‘LessThanOrEqual’, ‘GreaterThan’, ‘GreaterThanOrEqual’
  - negate_condition (bool) – Describes if this is negate condition or not
  - match_values (list[str]) – Required. The match value for the condition of the delivery rule
  - transforms (list[str or Transform]) – List of transforms

  `odatatype` = '#Microsoft.Azure.Cdn.Models.DeliveryRulePostArgsConditionParameters'

class `azure.mgmt.cdn.models.``Profile`(*, location: str, sku, tags=None, **kwargs)

  Bases: `azure.mgmt.cdn.models._models_py3.TrackedResource`

  CDN profile is a logical grouping of endpoints that share the same settings, such as CDN provider and pricing tier.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables:

  - id (str) – Resource ID.
  - name (str) – Resource name.
  - type (str) – Resource type.
  - resource_state (str or ProfileResourceState) – Resource status of the profile. Possible values include: ‘Creating’, ‘Active’, ‘Deleting’, ‘Disabled’
  - provisioning_state (str) – Provisioning status of the profile.

  Parameters:

  - location (str) – Required. Resource location.
  - tags (dict[str, str]) – Resource tags.
  - sku (Sku) – Required. The pricing tier (defines a CDN provider, feature list and rate) of the CDN profile.

class `azure.mgmt.cdn.models.``ProfileUpdateParameters`(*, tags=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Properties required to update a profile.

  Parameters: | tags (dict[str, str]) – Profile tags

class `azure.mgmt.cdn.models.``ProxyResource`(**kwargs)

  Bases: `azure.mgmt.cdn.models._models_py3.Resource`

  The resource model definition for a ARM proxy resource. It will have everything other than required location and tags.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - id (str) – Resource ID.
  - name (str) – Resource name.
  - type (str) – Resource type.

class `azure.mgmt.cdn.models.``PurgeParameters`(*, content_paths, **kwargs)

  Bases: `msrest.serialization.Model`

  Parameters required for content purge.

  All required parameters must be populated in order to send to Azure.

  Parameters: | content_paths (list[str]) – Required. The path to the content to be purged. Can describe a file path or a wild card directory.

class `azure.mgmt.cdn.models.``QueryStringMatchConditionParameters`(*, operator, match_values, negate_condition: bool = None, transforms=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Defines the parameters for QueryString match conditions.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables: | odatatype (str) – Required. Default value: “#Microsoft.Azure.Cdn.Models.DeliveryRuleQueryStringConditionParameters” .

  Parameters:

  - operator (str or QueryStringOperator) – Required. Describes operator to be matched. Possible values include: ‘Any’, ‘Equal’, ‘Contains’, ‘BeginsWith’, ‘EndsWith’, ‘LessThan’, ‘LessThanOrEqual’, ‘GreaterThan’, ‘GreaterThanOrEqual’
  - negate_condition (bool) – Describes if this is negate condition or not
  - match_values (list[str]) – Required. The match value for the condition of the delivery rule
  - transforms (list[str or Transform]) – List of transforms

  `odatatype` = '#Microsoft.Azure.Cdn.Models.DeliveryRuleQueryStringConditionParameters'

class `azure.mgmt.cdn.models.``RateLimitRule`(*, name: str, priority: int, match_conditions, action, rate_limit_threshold: int, rate_limit_duration_in_minutes: int, enabled_state=None, **kwargs)

  Bases: `azure.mgmt.cdn.models._models_py3.CustomRule`

  Defines a rate limiting rule that can be included in a waf policy.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - name (str) – Required. Defines the name of the custom rule
  - enabled_state (str or CustomRuleEnabledState) – Describes if the custom rule is in enabled or disabled state. Defaults to Enabled if not specified. Possible values include: ‘Disabled’, ‘Enabled’
  - priority (int) – Required. Defines in what order this rule be evaluated in the overall list of custom rules
  - match_conditions (list[MatchCondition]) – Required. List of match conditions.
  - action (str or ActionType) – Required. Describes what action to be applied when rule matches. Possible values include: ‘Allow’, ‘Block’, ‘Log’, ‘Redirect’
  - rate_limit_threshold (int) – Required. Defines rate limit threshold.
  - rate_limit_duration_in_minutes (int) – Required. Defines rate limit duration. Default is 1 minute.

class `azure.mgmt.cdn.models.``RateLimitRuleList`(*, rules=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Defines contents of rate limit rules.

  Parameters: | rules (list[RateLimitRule]) – List of rules

class `azure.mgmt.cdn.models.``RemoteAddressMatchConditionParameters`(*, operator, match_values, negate_condition: bool = None, transforms=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Defines the parameters for RemoteAddress match conditions.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables: | odatatype (str) – Required. Default value: “#Microsoft.Azure.Cdn.Models.DeliveryRuleRemoteAddressConditionParameters” .

  Parameters:

  - operator (str or RemoteAddressOperator) – Required. Describes operator to be matched. Possible values include: ‘Any’, ‘IPMatch’, ‘GeoMatch’
  - negate_condition (bool) – Describes if this is negate condition or not
  - match_values (list[str]) – Required. Match values to match against. The operator will apply to each value in here with OR semantics. If any of them match the variable with the given operator this match condition is considered a match.
  - transforms (list[str or Transform]) – List of transforms

  `odatatype` = '#Microsoft.Azure.Cdn.Models.DeliveryRuleRemoteAddressConditionParameters'

class `azure.mgmt.cdn.models.``RequestBodyMatchConditionParameters`(*, operator, match_values, negate_condition: bool = None, transforms=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Defines the parameters for RequestBody match conditions.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables: | odatatype (str) – Required. Default value: “#Microsoft.Azure.Cdn.Models.DeliveryRuleRequestBodyConditionParameters” .

  Parameters:

  - operator (str or RequestBodyOperator) – Required. Describes operator to be matched. Possible values include: ‘Any’, ‘Equal’, ‘Contains’, ‘BeginsWith’, ‘EndsWith’, ‘LessThan’, ‘LessThanOrEqual’, ‘GreaterThan’, ‘GreaterThanOrEqual’
  - negate_condition (bool) – Describes if this is negate condition or not
  - match_values (list[str]) – Required. The match value for the condition of the delivery rule
  - transforms (list[str or Transform]) – List of transforms

  `odatatype` = '#Microsoft.Azure.Cdn.Models.DeliveryRuleRequestBodyConditionParameters'

class `azure.mgmt.cdn.models.``RequestHeaderMatchConditionParameters`(*, selector: str, operator, match_values, negate_condition: bool = None, transforms=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Defines the parameters for RequestHeader match conditions.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables: | odatatype (str) – Required. Default value: “#Microsoft.Azure.Cdn.Models.DeliveryRuleRequestHeaderConditionParameters” .

  Parameters:

  - selector (str) – Required. Name of Header to be matched
  - operator (str or RequestHeaderOperator) – Required. Describes operator to be matched. Possible values include: ‘Any’, ‘Equal’, ‘Contains’, ‘BeginsWith’, ‘EndsWith’, ‘LessThan’, ‘LessThanOrEqual’, ‘GreaterThan’, ‘GreaterThanOrEqual’
  - negate_condition (bool) – Describes if this is negate condition or not
  - match_values (list[str]) – Required. The match value for the condition of the delivery rule
  - transforms (list[str or Transform]) – List of transforms

  `odatatype` = '#Microsoft.Azure.Cdn.Models.DeliveryRuleRequestHeaderConditionParameters'

class `azure.mgmt.cdn.models.``RequestMethodMatchConditionParameters`(*, match_values, negate_condition: bool = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Defines the parameters for RequestMethod match conditions.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables:

  - odatatype (str) – Required. Default value: “#Microsoft.Azure.Cdn.Models.DeliveryRuleRequestMethodConditionParameters” .
  - operator (str) – Required. Describes operator to be matched. Default value: “Equal” .

  Parameters:

  - negate_condition (bool) – Describes if this is negate condition or not
  - match_values (list[str]) – Required. The match value for the condition of the delivery rule

  `odatatype` = '#Microsoft.Azure.Cdn.Models.DeliveryRuleRequestMethodConditionParameters'
  `operator` = 'Equal'

class `azure.mgmt.cdn.models.``RequestSchemeMatchConditionParameters`(*, match_values, negate_condition: bool = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Defines the parameters for RequestScheme match conditions .

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables:

  - odatatype (str) – Required. Default value: “#Microsoft.Azure.Cdn.Models.DeliveryRuleRequestSchemeConditionParameters” .
  - operator (str) – Required. Describes operator to be matched. Default value: “Equal” .

  Parameters:

  - negate_condition (bool) – Describes if this is negate condition or not
  - match_values (list[str]) – Required. The match value for the condition of the delivery rule

  `odatatype` = '#Microsoft.Azure.Cdn.Models.DeliveryRuleRequestSchemeConditionParameters'
  `operator` = 'Equal'

class `azure.mgmt.cdn.models.``RequestUriMatchConditionParameters`(*, operator, match_values, negate_condition: bool = None, transforms=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Defines the parameters for RequestUri match conditions.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables: | odatatype (str) – Required. Default value: “#Microsoft.Azure.Cdn.Models.DeliveryRuleRequestUriConditionParameters” .

  Parameters:

  - operator (str or RequestUriOperator) – Required. Describes operator to be matched. Possible values include: ‘Any’, ‘Equal’, ‘Contains’, ‘BeginsWith’, ‘EndsWith’, ‘LessThan’, ‘LessThanOrEqual’, ‘GreaterThan’, ‘GreaterThanOrEqual’
  - negate_condition (bool) – Describes if this is negate condition or not
  - match_values (list[str]) – Required. The match value for the condition of the delivery rule
  - transforms (list[str or Transform]) – List of transforms

  `odatatype` = '#Microsoft.Azure.Cdn.Models.DeliveryRuleRequestUriConditionParameters'

class `azure.mgmt.cdn.models.``Resource`(**kwargs)

  Bases: `msrest.serialization.Model`

  The core properties of ARM resources.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - id (str) – Resource ID.
  - name (str) – Resource name.
  - type (str) – Resource type.

class `azure.mgmt.cdn.models.``ResourceUsage`(**kwargs)

  Bases: `msrest.serialization.Model`

  Output of check resource usage API.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - resource_type (str) – Resource type for which the usage is provided.
  - unit (str) – Unit of the usage. e.g. Count.
  - current_value (int) – Actual value of usage on the specified resource type.
  - limit (int) – Quota of the specified resource type.

class `azure.mgmt.cdn.models.``Sku`(*, name=None, **kwargs)

  Bases: `msrest.serialization.Model`

  The pricing tier (defines a CDN provider, feature list and rate) of the CDN profile.

  Parameters: | name (str or SkuName) – Name of the pricing tier. Possible values include: ‘Standard_Verizon’, ‘Premium_Verizon’, ‘Custom_Verizon’, ‘Standard_Akamai’, ‘Standard_ChinaCdn’, ‘Standard_Microsoft’, ‘Premium_ChinaCdn’

class `azure.mgmt.cdn.models.``SsoUri`(**kwargs)

  Bases: `msrest.serialization.Model`

  The URI required to login to the supplemental portal from the Azure portal.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables: | sso_uri_value (str) – The URI used to login to the supplemental portal.

class `azure.mgmt.cdn.models.``SupportedOptimizationTypesListResult`(**kwargs)

  Bases: `msrest.serialization.Model`

  The result of the GetSupportedOptimizationTypes API.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables: | supported_optimization_types (list[str or OptimizationType]) – Supported optimization types for a profile.

class `azure.mgmt.cdn.models.``TrackedResource`(*, location: str, tags=None, **kwargs)

  Bases: `azure.mgmt.cdn.models._models_py3.Resource`

  The resource model definition for a ARM tracked top level resource.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables:

  - id (str) – Resource ID.
  - name (str) – Resource name.
  - type (str) – Resource type.

  Parameters:

  - location (str) – Required. Resource location.
  - tags (dict[str, str]) – Resource tags.

class `azure.mgmt.cdn.models.``UrlFileExtensionMatchConditionParameters`(*, operator, match_values, negate_condition: bool = None, transforms=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Defines the parameters for UrlFileExtension match conditions.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables: | odatatype (str) – Required. Default value: “#Microsoft.Azure.Cdn.Models.DeliveryRuleUrlFileExtensionMatchConditionParameters” .

  Parameters:

  - operator (str or UrlFileExtensionOperator) – Required. Describes operator to be matched. Possible values include: ‘Any’, ‘Equal’, ‘Contains’, ‘BeginsWith’, ‘EndsWith’, ‘LessThan’, ‘LessThanOrEqual’, ‘GreaterThan’, ‘GreaterThanOrEqual’
  - negate_condition (bool) – Describes if this is negate condition or not
  - match_values (list[str]) – Required. The match value for the condition of the delivery rule
  - transforms (list[str or Transform]) – List of transforms

  `odatatype` = '#Microsoft.Azure.Cdn.Models.DeliveryRuleUrlFileExtensionMatchConditionParameters'

class `azure.mgmt.cdn.models.``UrlFileNameMatchConditionParameters`(*, operator, match_values, negate_condition: bool = None, transforms=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Defines the parameters for UrlFilename match conditions.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables: | odatatype (str) – Required. Default value: “#Microsoft.Azure.Cdn.Models.DeliveryRuleUrlFilenameConditionParameters” .

  Parameters:

  - operator (str or UrlFileNameOperator) – Required. Describes operator to be matched. Possible values include: ‘Any’, ‘Equal’, ‘Contains’, ‘BeginsWith’, ‘EndsWith’, ‘LessThan’, ‘LessThanOrEqual’, ‘GreaterThan’, ‘GreaterThanOrEqual’
  - negate_condition (bool) – Describes if this is negate condition or not
  - match_values (list[str]) – Required. The match value for the condition of the delivery rule
  - transforms (list[str or Transform]) – List of transforms

  `odatatype` = '#Microsoft.Azure.Cdn.Models.DeliveryRuleUrlFilenameConditionParameters'

class `azure.mgmt.cdn.models.``UrlPathMatchConditionParameters`(*, operator, match_values, negate_condition: bool = None, transforms=None, **kwargs)

  Bases: `msrest.serialization.Model`

  Defines the parameters for UrlPath match conditions.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables: | odatatype (str) – Required. Default value: “#Microsoft.Azure.Cdn.Models.DeliveryRuleUrlPathMatchConditionParameters” .

  Parameters:

  - operator (str or UrlPathOperator) – Required. Describes operator to be matched. Possible values include: ‘Any’, ‘Equal’, ‘Contains’, ‘BeginsWith’, ‘EndsWith’, ‘LessThan’, ‘LessThanOrEqual’, ‘GreaterThan’, ‘GreaterThanOrEqual’, ‘Wildcard’
  - negate_condition (bool) – Describes if this is negate condition or not
  - match_values (list[str]) – Required. The match value for the condition of the delivery rule
  - transforms (list[str or Transform]) – List of transforms

  `odatatype` = '#Microsoft.Azure.Cdn.Models.DeliveryRuleUrlPathMatchConditionParameters'

class `azure.mgmt.cdn.models.``UrlRedirectAction`(*, parameters, **kwargs)

  Bases: `azure.mgmt.cdn.models._models_py3.DeliveryRuleAction`

  Defines the url redirect action for the delivery rule.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - name (str) – Required. Constant filled by server.
  - parameters (UrlRedirectActionParameters) – Required. Defines the parameters for the action.

class `azure.mgmt.cdn.models.``UrlRedirectActionParameters`(*, redirect_type, destination_protocol=None, custom_path: str = None, custom_hostname: str = None, custom_query_string: str = None, custom_fragment: str = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Defines the parameters for the url redirect action.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables: | odatatype (str) – Required. Default value: “#Microsoft.Azure.Cdn.Models.DeliveryRuleUrlRedirectActionParameters” .

  Parameters:

  - redirect_type (str or RedirectType) – Required. The redirect type the rule will use when redirecting traffic. Possible values include: ‘Moved’, ‘Found’, ‘TemporaryRedirect’, ‘PermanentRedirect’
  - destination_protocol (str or DestinationProtocol) – Protocol to use for the redirect. The default value is MatchRequest. Possible values include: ‘MatchRequest’, ‘Http’, ‘Https’
  - custom_path (str) – The full path to redirect. Path cannot be empty and must start with /. Leave empty to use the incoming path as destination path.
  - custom_hostname (str) – Host to redirect. Leave empty to use the incoming host as the destination host.
  - custom_query_string (str) – The set of query strings to be placed in the redirect URL. Setting this value would replace any existing query string; leave empty to preserve the incoming query string. Query string must be in <key>=<value> format. ? and & will be added automatically so do not include them.
  - custom_fragment (str) – Fragment to add to the redirect URL. Fragment is the part of the URL that comes after #. Do not include the #.

  `odatatype` = '#Microsoft.Azure.Cdn.Models.DeliveryRuleUrlRedirectActionParameters'

class `azure.mgmt.cdn.models.``UrlRewriteAction`(*, parameters, **kwargs)

  Bases: `azure.mgmt.cdn.models._models_py3.DeliveryRuleAction`

  Defines the url rewrite action for the delivery rule.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - name (str) – Required. Constant filled by server.
  - parameters (UrlRewriteActionParameters) – Required. Defines the parameters for the action.

class `azure.mgmt.cdn.models.``UrlRewriteActionParameters`(*, source_pattern: str, destination: str, preserve_unmatched_path: bool = None, **kwargs)

  Bases: `msrest.serialization.Model`

  Defines the parameters for the url rewrite action.

  Variables are only populated by the server, and will be ignored when sending a request.

  All required parameters must be populated in order to send to Azure.

  Variables: | odatatype (str) – Required. Default value: “#Microsoft.Azure.Cdn.Models.DeliveryRuleUrlRewriteActionParameters” .

  Parameters:

  - source_pattern (str) – Required. define a request URI pattern that identifies the type of requests that may be rewritten. Currently, source pattern uses a prefix-based match. To match all URL paths, use “/” as the source pattern value. To match only the root directory and re-write this path, use the origin path field
  - destination (str) – Required. Define the destination path for be used in the rewrite. This will overwrite the source pattern
  - preserve_unmatched_path (bool) – If True, the remaining path after the source pattern will be appended to the new destination path.

  `odatatype` = '#Microsoft.Azure.Cdn.Models.DeliveryRuleUrlRewriteActionParameters'

class `azure.mgmt.cdn.models.``UserManagedHttpsParameters`(*, protocol_type, certificate_source_parameters, minimum_tls_version=None, **kwargs)

  Bases: `azure.mgmt.cdn.models._models_py3.CustomDomainHttpsParameters`

  Defines the certificate source parameters using user’s keyvault certificate for enabling SSL.

  All required parameters must be populated in order to send to Azure.

  Parameters:

  - protocol_type (str or ProtocolType) – Required. Defines the TLS extension protocol that is used for secure delivery. Possible values include: ‘ServerNameIndication’, ‘IPBased’
  - minimum_tls_version (str or MinimumTlsVersion) – TLS protocol version that will be used for Https. Possible values include: ‘None’, ‘TLS10’, ‘TLS12’
  - certificate_source (str) – Required. Constant filled by server.
  - certificate_source_parameters (KeyVaultCertificateSourceParameters) – Required. Defines the certificate source parameters using user’s keyvault certificate for enabling SSL.

class `azure.mgmt.cdn.models.``ValidateCustomDomainInput`(*, host_name: str, **kwargs)

  Bases: `msrest.serialization.Model`

  Input of the custom domain to be validated for DNS mapping.

  All required parameters must be populated in order to send to Azure.

  Parameters: | host_name (str) – Required. The host name of the custom domain. Must be a domain name.

class `azure.mgmt.cdn.models.``ValidateCustomDomainOutput`(**kwargs)

  Bases: `msrest.serialization.Model`

  Output of custom domain validation.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - custom_domain_validated (bool) – Indicates whether the custom domain is valid or not.
  - reason (str) – The reason why the custom domain is not valid.
  - message (str) – Error message describing why the custom domain is not valid.

class `azure.mgmt.cdn.models.``ValidateProbeInput`(*, probe_url: str, **kwargs)

  Bases: `msrest.serialization.Model`

  Input of the validate probe API.

  All required parameters must be populated in order to send to Azure.

  Parameters: | probe_url (str) – Required. The probe URL to validate.

class `azure.mgmt.cdn.models.``ValidateProbeOutput`(**kwargs)

  Bases: `msrest.serialization.Model`

  Output of the validate probe API.

  Variables are only populated by the server, and will be ignored when sending a request.

  Variables:

  - is_valid (bool) – Indicates whether the probe URL is accepted or not.
  - error_code (str) – Specifies the error code when the probe url is not accepted.
  - message (str) – The detailed error message describing why the probe URL is not accepted.

class `azure.mgmt.cdn.models.``ProfilePaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `Profile` object

class `azure.mgmt.cdn.models.``ResourceUsagePaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `ResourceUsage` object

class `azure.mgmt.cdn.models.``EndpointPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `Endpoint` object

class `azure.mgmt.cdn.models.``OriginPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `Origin` object

class `azure.mgmt.cdn.models.``CustomDomainPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `CustomDomain` object

class `azure.mgmt.cdn.models.``OperationPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `Operation` object

class `azure.mgmt.cdn.models.``EdgeNodePaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `EdgeNode` object

class `azure.mgmt.cdn.models.``CdnWebApplicationFirewallPolicyPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `CdnWebApplicationFirewallPolicy` object

class `azure.mgmt.cdn.models.``ManagedRuleSetDefinitionPaged`(*args, **kwargs)

  Bases: `msrest.paging.Paged`

  A paging container for iterating over a list of `ManagedRuleSetDefinition` object

class `azure.mgmt.cdn.models.``SkuName`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `custom_verizon` = 'Custom_Verizon'
  `premium_china_cdn` = 'Premium_ChinaCdn'
  `premium_verizon` = 'Premium_Verizon'
  `standard_akamai` = 'Standard_Akamai'
  `standard_china_cdn` = 'Standard_ChinaCdn'
  `standard_microsoft` = 'Standard_Microsoft'
  `standard_verizon` = 'Standard_Verizon'

class `azure.mgmt.cdn.models.``ProfileResourceState`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `active` = 'Active'
  `creating` = 'Creating'
  `deleting` = 'Deleting'
  `disabled` = 'Disabled'

class `azure.mgmt.cdn.models.``OptimizationType`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `dynamic_site_acceleration` = 'DynamicSiteAcceleration'
  `general_media_streaming` = 'GeneralMediaStreaming'
  `general_web_delivery` = 'GeneralWebDelivery'
  `large_file_download` = 'LargeFileDownload'
  `video_on_demand_media_streaming` = 'VideoOnDemandMediaStreaming'

class `azure.mgmt.cdn.models.``EndpointResourceState`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `creating` = 'Creating'
  `deleting` = 'Deleting'
  `running` = 'Running'
  `starting` = 'Starting'
  `stopped` = 'Stopped'
  `stopping` = 'Stopping'

class `azure.mgmt.cdn.models.``QueryStringCachingBehavior`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `bypass_caching` = 'BypassCaching'
  `ignore_query_string` = 'IgnoreQueryString'
  `not_set` = 'NotSet'
  `use_query_string` = 'UseQueryString'

class `azure.mgmt.cdn.models.``GeoFilterActions`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `allow` = 'Allow'
  `block` = 'Block'

class `azure.mgmt.cdn.models.``RemoteAddressOperator`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `any` = 'Any'
  `geo_match` = 'GeoMatch'
  `ip_match` = 'IPMatch'

class `azure.mgmt.cdn.models.``Transform`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `lowercase` = 'Lowercase'
  `uppercase` = 'Uppercase'

class `azure.mgmt.cdn.models.``QueryStringOperator`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `any` = 'Any'
  `begins_with` = 'BeginsWith'
  `contains` = 'Contains'
  `ends_with` = 'EndsWith'
  `equal` = 'Equal'
  `greater_than` = 'GreaterThan'
  `greater_than_or_equal` = 'GreaterThanOrEqual'
  `less_than` = 'LessThan'
  `less_than_or_equal` = 'LessThanOrEqual'

class `azure.mgmt.cdn.models.``PostArgsOperator`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `any` = 'Any'
  `begins_with` = 'BeginsWith'
  `contains` = 'Contains'
  `ends_with` = 'EndsWith'
  `equal` = 'Equal'
  `greater_than` = 'GreaterThan'
  `greater_than_or_equal` = 'GreaterThanOrEqual'
  `less_than` = 'LessThan'
  `less_than_or_equal` = 'LessThanOrEqual'

class `azure.mgmt.cdn.models.``RequestUriOperator`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `any` = 'Any'
  `begins_with` = 'BeginsWith'
  `contains` = 'Contains'
  `ends_with` = 'EndsWith'
  `equal` = 'Equal'
  `greater_than` = 'GreaterThan'
  `greater_than_or_equal` = 'GreaterThanOrEqual'
  `less_than` = 'LessThan'
  `less_than_or_equal` = 'LessThanOrEqual'

class `azure.mgmt.cdn.models.``RequestHeaderOperator`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `any` = 'Any'
  `begins_with` = 'BeginsWith'
  `contains` = 'Contains'
  `ends_with` = 'EndsWith'
  `equal` = 'Equal'
  `greater_than` = 'GreaterThan'
  `greater_than_or_equal` = 'GreaterThanOrEqual'
  `less_than` = 'LessThan'
  `less_than_or_equal` = 'LessThanOrEqual'

class `azure.mgmt.cdn.models.``RequestBodyOperator`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `any` = 'Any'
  `begins_with` = 'BeginsWith'
  `contains` = 'Contains'
  `ends_with` = 'EndsWith'
  `equal` = 'Equal'
  `greater_than` = 'GreaterThan'
  `greater_than_or_equal` = 'GreaterThanOrEqual'
  `less_than` = 'LessThan'
  `less_than_or_equal` = 'LessThanOrEqual'

class `azure.mgmt.cdn.models.``UrlPathOperator`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `any` = 'Any'
  `begins_with` = 'BeginsWith'
  `contains` = 'Contains'
  `ends_with` = 'EndsWith'
  `equal` = 'Equal'
  `greater_than` = 'GreaterThan'
  `greater_than_or_equal` = 'GreaterThanOrEqual'
  `less_than` = 'LessThan'
  `less_than_or_equal` = 'LessThanOrEqual'
  `wildcard` = 'Wildcard'

class `azure.mgmt.cdn.models.``UrlFileExtensionOperator`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `any` = 'Any'
  `begins_with` = 'BeginsWith'
  `contains` = 'Contains'
  `ends_with` = 'EndsWith'
  `equal` = 'Equal'
  `greater_than` = 'GreaterThan'
  `greater_than_or_equal` = 'GreaterThanOrEqual'
  `less_than` = 'LessThan'
  `less_than_or_equal` = 'LessThanOrEqual'

class `azure.mgmt.cdn.models.``UrlFileNameOperator`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `any` = 'Any'
  `begins_with` = 'BeginsWith'
  `contains` = 'Contains'
  `ends_with` = 'EndsWith'
  `equal` = 'Equal'
  `greater_than` = 'GreaterThan'
  `greater_than_or_equal` = 'GreaterThanOrEqual'
  `less_than` = 'LessThan'
  `less_than_or_equal` = 'LessThanOrEqual'

class `azure.mgmt.cdn.models.``CookiesOperator`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `any` = 'Any'
  `begins_with` = 'BeginsWith'
  `contains` = 'Contains'
  `ends_with` = 'EndsWith'
  `equal` = 'Equal'
  `greater_than` = 'GreaterThan'
  `greater_than_or_equal` = 'GreaterThanOrEqual'
  `less_than` = 'LessThan'
  `less_than_or_equal` = 'LessThanOrEqual'

class `azure.mgmt.cdn.models.``RedirectType`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `found` = 'Found'
  `moved` = 'Moved'
  `permanent_redirect` = 'PermanentRedirect'
  `temporary_redirect` = 'TemporaryRedirect'

class `azure.mgmt.cdn.models.``DestinationProtocol`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `http` = 'Http'
  `https` = 'Https'
  `match_request` = 'MatchRequest'

class `azure.mgmt.cdn.models.``HeaderAction`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `append` = 'Append'
  `delete` = 'Delete'
  `overwrite` = 'Overwrite'

class `azure.mgmt.cdn.models.``CacheBehavior`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `bypass_cache` = 'BypassCache'
  `override` = 'Override'
  `set_if_missing` = 'SetIfMissing'

class `azure.mgmt.cdn.models.``QueryStringBehavior`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `exclude` = 'Exclude'
  `exclude_all` = 'ExcludeAll'
  `include` = 'Include'
  `include_all` = 'IncludeAll'

class `azure.mgmt.cdn.models.``OriginResourceState`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `active` = 'Active'
  `creating` = 'Creating'
  `deleting` = 'Deleting'

class `azure.mgmt.cdn.models.``CustomDomainResourceState`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `active` = 'Active'
  `creating` = 'Creating'
  `deleting` = 'Deleting'

class `azure.mgmt.cdn.models.``CustomHttpsProvisioningState`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `disabled` = 'Disabled'
  `disabling` = 'Disabling'
  `enabled` = 'Enabled'
  `enabling` = 'Enabling'
  `failed` = 'Failed'

class `azure.mgmt.cdn.models.``CustomHttpsProvisioningSubstate`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `certificate_deleted` = 'CertificateDeleted'
  `certificate_deployed` = 'CertificateDeployed'
  `deleting_certificate` = 'DeletingCertificate'
  `deploying_certificate` = 'DeployingCertificate'
  `domain_control_validation_request_approved` = 'DomainControlValidationRequestApproved'
  `domain_control_validation_request_rejected` = 'DomainControlValidationRequestRejected'
  `domain_control_validation_request_timed_out` = 'DomainControlValidationRequestTimedOut'
  `issuing_certificate` = 'IssuingCertificate'
  `pending_domain_control_validation_request_approval` = 'PendingDomainControlValidationREquestApproval'
  `submitting_domain_control_validation_request` = 'SubmittingDomainControlValidationRequest'

class `azure.mgmt.cdn.models.``ProtocolType`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `ip_based` = 'IPBased'
  `server_name_indication` = 'ServerNameIndication'

class `azure.mgmt.cdn.models.``MinimumTlsVersion`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `none` = 'None'
  `tls10` = 'TLS10'
  `tls12` = 'TLS12'

class `azure.mgmt.cdn.models.``CertificateType`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `dedicated` = 'Dedicated'
  `shared` = 'Shared'

class `azure.mgmt.cdn.models.``ResourceType`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `microsoft_cdn_profiles_endpoints` = 'Microsoft.Cdn/Profiles/Endpoints'

class `azure.mgmt.cdn.models.``PolicyEnabledState`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `disabled` = 'Disabled'
  `enabled` = 'Enabled'

class `azure.mgmt.cdn.models.``PolicyMode`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `detection` = 'Detection'
  `prevention` = 'Prevention'

class `azure.mgmt.cdn.models.``CustomRuleEnabledState`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `disabled` = 'Disabled'
  `enabled` = 'Enabled'

class `azure.mgmt.cdn.models.``MatchVariable`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `cookies` = 'Cookies'
  `country` = 'Country'
  `post_args` = 'PostArgs'
  `query_string` = 'QueryString'
  `remote_addr` = 'RemoteAddr'
  `request_body` = 'RequestBody'
  `request_header` = 'RequestHeader'
  `request_method` = 'RequestMethod'
  `request_uri` = 'RequestUri'

class `azure.mgmt.cdn.models.``Operator`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `any` = 'Any'
  `begins_with` = 'BeginsWith'
  `contains` = 'Contains'
  `ends_with` = 'EndsWith'
  `equal` = 'Equal'
  `geo_match` = 'GeoMatch'
  `greater_than` = 'GreaterThan'
  `greater_than_or_equal` = 'GreaterThanOrEqual'
  `ip_match` = 'IPMatch'
  `less_than` = 'LessThan'
  `less_than_or_equal` = 'LessThanOrEqual'
  `reg_ex` = 'RegEx'

class `azure.mgmt.cdn.models.``TransformType`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `lowercase` = 'Lowercase'
  `remove_nulls` = 'RemoveNulls'
  `trim` = 'Trim'
  `uppercase` = 'Uppercase'
  `url_decode` = 'UrlDecode'
  `url_encode` = 'UrlEncode'

class `azure.mgmt.cdn.models.``ActionType`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `allow` = 'Allow'
  `block` = 'Block'
  `log` = 'Log'
  `redirect` = 'Redirect'

class `azure.mgmt.cdn.models.``ManagedRuleEnabledState`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `disabled` = 'Disabled'
  `enabled` = 'Enabled'

class `azure.mgmt.cdn.models.``ProvisioningState`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `creating` = 'Creating'
  `failed` = 'Failed'
  `succeeded` = 'Succeeded'

class `azure.mgmt.cdn.models.``PolicyResourceState`

  Bases: `str`, `enum.Enum`

  An enumeration.

  `creating` = 'Creating'
  `deleting` = 'Deleting'
  `disabled` = 'Disabled'
  `disabling` = 'Disabling'
  `enabled` = 'Enabled'
  `enabling` = 'Enabling'